searchNodes=[{"doc":"Enter point for validate data structure. If you want to validate a data set you first have to take into account the following important points: 1 - This dependence is based on a schema-data system in which two data structures are received, one called schema and another called data which have to be related in some way. 2 - The creation of a good schema is essential for the validation of data, remember that the library validates the data in a sequential way, therefore it is the schema that decides which is validated first and which rule is validated first. If it fails, it will always give the corresponding error. The schema should be a keyw ord list in the following way, examples: @schema [ id: [:required] ] another example: @schema [ id: [:required, length: 16], name: [type: string, max_legnth: 24] ] The last example first validate the id data with the schema [:required, lenght: 16], if the required fault, return this error an not continue with the validation. the rules that are available right now are: :accepted. between: {min, max}, where min and max are integers. default: default_value. :email. in: []. length: equal_length, where equal_length is a integer. max_length: max, where max is a integer. min_length: min, where min is a integer. :required type: type, where type can be: :atom, :string, :list, :map, :tuple, :number, :integer, :float 3 - the data should always be a map. At the moment nothing else is accepted, if you want to validate a specific data I recommend you to call directly to the rules, each one of them has its documentation with some example of operation and its corresponding tests. Example of data: %{ &quot;id&quot; =&gt; 12_345, &quot;name&quot; =&gt; &quot;picolo&quot; } 4- The entry point is a macro called validate, which we will use as follows: use Exvalidate and the last: validate(data, schema)","ref":"Exvalidate.html","title":"Exvalidate","type":"module"},{"doc":"Plug for validate request into the router file. For validate the request we need create a schema keywordlist with the rules assigned to params. Uses 1- To add the exvalidate middleware in your plug file: plug(:match) plug(PlugValidate, on_error: &amp;PlugError.json_error/2) plug(:dispatch) 2- Schema example: @schema = [ name: [between: {2, 16}] ] 3a- if the request contains query string (for GET request) the validation will be: &quot;private: %{validate_query: @schema}&quot; get &quot;/test&quot;, private: %{validate_query: @schema} do 3b- if the request container body params (for POST request) the validation will be: &quot;private: %{validate_body: @schema}&quot; post &quot;/test&quot;, private: %{validate_body: @schema} do","ref":"Exvalidate.Plug.html","title":"Exvalidate.Plug","type":"module"},{"doc":"Define the error functions for the plug. We can choose return errors in the next formats: Json: using the json_error function. Plain Text: using the plain_error function. If you want create a custom error function, you can define this function in a module and then call the plug validate: plug(PlugValidate, on_error: &amp;PlugError.json_error/2) You set the &quot;on_error&quot; param with the your custom function.","ref":"Exvalidate.PlugError.html","title":"Exvalidate.PlugError","type":"module"},{"doc":"return the error in json format.","ref":"Exvalidate.PlugError.html#json_error/2","title":"Exvalidate.PlugError.json_error/2","type":"function"},{"doc":"return the error in text plain format.","ref":"Exvalidate.PlugError.html#plain_error/2","title":"Exvalidate.PlugError.plain_error/2","type":"function"},{"doc":"The field under validation must be &quot;yes&quot;, &quot;on&quot;, 1, or true. Examples iex(3)&gt; Exvalidate.Rules.Accepted.validating(:accepted, nil) {:error, :not_accepted} iex(3)&gt; Exvalidate.Rules.Accepted.validating(:accepted, &quot;yes&quot;) {:ok, &quot;yes&quot;} iex(3)&gt; Exvalidate.Rules.Accepted.validating(:accepted, &quot;on&quot;) {:ok, &quot;on&quot;} iex(3)&gt; Exvalidate.Rules.Accepted.validating(:accepted, 1) {:ok, 1} iex(3)&gt; Exvalidate.Rules.Accepted.validating(:accepted, true) {:ok, true} For see examples go to the tests: test/rules/accepted_test.exs","ref":"Exvalidate.Rules.Accepted.html","title":"Exvalidate.Rules.Accepted","type":"module"},{"doc":"The field under validation must have a size between the given min and max. Strings: length is between those values. Numerics: value is between those values. Lists: length of array is between those values. Tuple: length of tuple is between those values. Examples with string iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {&quot;6&quot;, &quot;10&quot;}}, &quot;Vegeta&quot;) {:error, :between_rule_wrong} iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {4, 20}}, &quot;Vegeta&quot;) {:ok, &quot;Vegeta&quot;} Examples with numerics iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {4, 20}}, 7) {:ok, 7} iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {4, 20}}, 35) {:error, :not_between_min_max} Examples with lists iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {4, 20}}, [&quot;Vegeta&quot;, &quot;Goku&quot;, &quot;Picolo&quot;, &quot;Krilin&quot;]) {:ok, [&quot;Vegeta&quot;, &quot;Goku&quot;, &quot;Picolo&quot;, &quot;Krilin&quot;]} iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {3, 5}}, [&quot;Vegeta&quot;, &quot;Krilin&quot;]) {:error, :not_between_min_max} Examples with tuple iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {4, 20}}, {&quot;Vegeta&quot;, &quot;Goku&quot;, &quot;Picolo&quot;, &quot;Krilin&quot;}) {:ok, {&quot;Vegeta&quot;, &quot;Goku&quot;, &quot;Picolo&quot;, &quot;Krilin&quot;}} iex(3)&gt; Exvalidate.Rules.Between.validating({:between, {4, 20}}, {&quot;Vegeta&quot;, &quot;Krilin&quot;}) {:error, :not_between_min_max} For see examples go to the tests: test/rules/between_test.exs","ref":"Exvalidate.Rules.Between.html","title":"Exvalidate.Rules.Between","type":"module"},{"doc":"Validate default rule, this rule validate if exists value. If exists value return this value, if not exists return default value. Examples iex(3)&gt; Exvalidate.Rules.Default.validating({:default, &quot;Son goku&quot;}, nil) {:ok, &quot;Son goku&quot;} iex(3)&gt; Exvalidate.Rules.Default.validating({:default, &quot;Son goku&quot;}, &quot;Son gohan&quot;) {:ok, &quot;Son gohan&quot;} For see examples go to the tests: test/rules/default_test.exs","ref":"Exvalidate.Rules.Default.html","title":"Exvalidate.Rules.Default","type":"module"},{"doc":"Validate email rule, return ok if email is valid, an error if is invalid. Examples iex(3)&gt; Exvalidate.Rules.Email.validating(:email, &quot;songoku.dragonball@gmail.com&quot;) {:ok, &quot;songoku.dragonball@gmail.com&quot;} iex(3)&gt; Exvalidate.Rules.Email.validating(:email, &quot;Son gohan&quot;) {:error, :email_invalid} For see examples go to the tests: test/rules/email_test.exs","ref":"Exvalidate.Rules.Email.html","title":"Exvalidate.Rules.Email","type":"module"},{"doc":"This module validate that the value or list of values are into the list. Types allowed: String. Number. List. Examples String iex(3)&gt; Exvalidate.Rules.In.validating({:in, [&quot;Vegeta&quot;, &quot;Kakarot&quot;]}, &quot;Vegeta&quot;) {:ok, &quot;Vegeta&quot;} iex(3)&gt; Exvalidate.Rules.In.validating({:in, [&quot;Vegeta&quot;, &quot;Kakarot&quot;]}, &quot;Boo&quot;) {:error, :in_not_in_list} Examples Number iex(3)&gt; Exvalidate.Rules.In.validating({:in, [1, 10.1]}, 10.1) {:ok, 10.1} iex(3)&gt; Exvalidate.Rules.In.validating({:in, [1, 10.1]}, 10) {:error, :in_not_in_list} Examples List iex(3)&gt; Exvalidate.Rules.In.validating({:in, [&quot;Vegeta&quot;, &quot;Kakarot&quot;, &quot;Picolo&quot;, &quot;Boo&quot;]}, [&quot;Vegeta&quot;, &quot;Boo&quot;]) {:ok, [&quot;Vegeta&quot;, &quot;Boo&quot;]} iex(3)&gt; Exvalidate.Rules.In.validating({:in, [&quot;Vegeta&quot;, &quot;Kakarot&quot;, &quot;Picolo&quot;, &quot;Boo&quot;]}, [&quot;Vegeta&quot;, &quot;Lufi&quot;, &quot;Boo&quot;]) {:error, :in_not_in_list} For see examples go to the tests: test/rules/in_test.exs","ref":"Exvalidate.Rules.In.html","title":"Exvalidate.Rules.In","type":"module"},{"doc":"","ref":"Exvalidate.Rules.In.html#t:input/0","title":"Exvalidate.Rules.In.input/0","type":"type"},{"doc":"This rules Specifies the exact length of value, the allowed types are: String: Number of characters allowed. List: exact number of items in the list. Tuple: exact number of items in the tuple. Examples string iex(3)&gt; Exvalidate.Rules.Length.validating({:length, 6}, &quot;Vegeta&quot;) {:ok, &quot;Vegeta&quot;} iex(3)&gt; Exvalidate.Rules.Length.validating({:length, 1}, &quot;Vegeta&quot;) {:error, :length_not_equal} Examples list iex(3)&gt; Exvalidate.Rules.Length.validating({:length, 2}, [&quot;Vegeta&quot;, &quot;Picolo&quot;]) {:ok, [&quot;Vegeta&quot;, &quot;Picolo&quot;]} iex(3)&gt; Exvalidate.Rules.Length.validating({:length, 2}, [&quot;Vegeta&quot;, &quot;Picolo&quot;, &quot;Bulma&quot;]) {:error, :length_not_equal} Examples tuple iex(3)&gt; Exvalidate.Rules.Length.validating({:length, 3}, {&quot;Vegeta&quot;, &quot;Piccolo&quot;, &quot;Krilin&quot;}) {:ok, {&quot;Vegeta&quot;, &quot;Piccolo&quot;, &quot;Krilin&quot;}} iex(3)&gt; Exvalidate.Rules.Length.validating({:length, 3}, {&quot;Vegeta&quot;}) {:error, :length_not_equal} For see examples go to the tests: test/rules/length_test.exs","ref":"Exvalidate.Rules.Length.html","title":"Exvalidate.Rules.Length","type":"module"},{"doc":"","ref":"Exvalidate.Rules.Length.html#t:input/0","title":"Exvalidate.Rules.Length.input/0","type":"type"},{"doc":"This module validate the max length of list and strings. Value types: String. Tuple. List. Examples string iex(3)&gt; Exvalidate.Rules.MaxLength.validating({:max_length, 3}, &quot;Boo&quot;) {:ok, &quot;Boo&quot;} iex(3)&gt; Exvalidate.Rules.MaxLength.validating({:max_length, 1}, &quot;Vegeta&quot;) {:error, :max_length_greater_than_max} Examples list iex(3)&gt; Exvalidate.Rules.MaxLength.validating({:max_length, 2}, [&quot;Vegeta&quot;, &quot;Picolo&quot;]) {:ok, [&quot;Vegeta&quot;, &quot;Picolo&quot;]} iex(3)&gt; Exvalidate.Rules.MaxLength.validating({:max_length, 2}, [&quot;Vegeta&quot;, &quot;Picolo&quot;, &quot;Bulma&quot;]) {:error, :max_length_greater_than_max} Examples tuple iex(3)&gt; Exvalidate.Rules.MaxLength.validating({:max_length, 3}, {&quot;Vegeta&quot;, &quot;Piccolo&quot;, &quot;Krilin&quot;}) {:ok, {&quot;Vegeta&quot;, &quot;Piccolo&quot;, &quot;Krilin&quot;}} iex(3)&gt; Exvalidate.Rules.MaxLength.validating({:max_length, 3}, {&quot;Vegeta&quot;}) {:error, :max_length_greater_than_max} For see examples go to the tests: test/rules/max_length_test.exs","ref":"Exvalidate.Rules.MaxLength.html","title":"Exvalidate.Rules.MaxLength","type":"module"},{"doc":"","ref":"Exvalidate.Rules.MaxLength.html#t:input/0","title":"Exvalidate.Rules.MaxLength.input/0","type":"type"},{"doc":"This module validate the length of list and strings. Value types: String. Tuple. List. Examples string iex(3)&gt; Exvalidate.Rules.MinLength.validating({:min_length, 3}, &quot;Boo&quot;) {:ok, &quot;Boo&quot;} iex(3)&gt; Exvalidate.Rules.MinLength.validating({:min_length, 20}, &quot;Vegeta&quot;) {:error, :min_length_lower_than_min} Examples list iex(3)&gt; Exvalidate.Rules.MinLength.validating({:min_length, 2}, [&quot;Vegeta&quot;, &quot;Picolo&quot;, &quot;Bulma&quot;]) {:ok, [&quot;Vegeta&quot;, &quot;Picolo&quot;, &quot;Bulma&quot;]} iex(3)&gt; Exvalidate.Rules.MinLength.validating({:min_length, 20}, [&quot;Vegeta&quot;]) {:error, :min_length_lower_than_min} Examples tuple iex(3)&gt; Exvalidate.Rules.MinLength.validating({:min_length, 5}, {&quot;Vegeta&quot;, &quot;Picolo&quot;, &quot;Bulma&quot;}) {:ok, {&quot;Vegeta&quot;, &quot;Picolo&quot;, &quot;Bulma&quot;}} iex(3)&gt; Exvalidate.Rules.MinLength.validating({:min_length, 1}, {&quot;Vegeta&quot;, &quot;Bulma&quot;}) {:error, :min_length_lower_than_min} For see examples go to the tests: test/rules/min_length_test.exs","ref":"Exvalidate.Rules.MinLength.html","title":"Exvalidate.Rules.MinLength","type":"module"},{"doc":"","ref":"Exvalidate.Rules.MinLength.html#t:input/0","title":"Exvalidate.Rules.MinLength.input/0","type":"type"},{"doc":"Required rule check the data content, if the content is nil or empty string the rule required return error. Examples iex(3)&gt; Exvalidate.Rules.Required.validating(:required, 1234) {:ok, 1234} iex(3)&gt; Exvalidate.Rules.Required.validating(:required, &quot;&quot;) {:error, :required_value_wrong} iex(3)&gt; Exvalidate.Rules.Required.validating(:required, nil) {:error, :required_value_wrong} For see examples go to the tests: test/rules/required_test.exs","ref":"Exvalidate.Rules.Required.html","title":"Exvalidate.Rules.Required","type":"module"},{"doc":"This validation check the type of variable. The checked types are the next: :string =&gt; &quot;name&quot;, &quot;address&quot;, &quot;language&quot;, :list =&gt; [&quot;name&quot;, &quot;address&quot;, &quot;language&quot;], :map =&gt; %{name: &quot;Vegeta&quot;, address: &quot;Vegeta planet&quot;}, :tuple =&gt; {:name, &quot;Vegeta&quot;}, :number =&gt; 23, 2.3, 4, 0.9, -0.9, -4, :integer =&gt; 23, 4, -4, :float =&gt; 2.3, 0.9, -0.9. :atom =&gt; :vegeta, :picolo :boolean =&gt; true, false Examples atom iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :atom}, :Saiyajin) {:ok, :Saiyajin} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :atom}, 33) {:error, :type_value_wrong} Examples string iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :string}, &quot;Saiyajin&quot;) {:ok, &quot;Boo&quot;} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :string}, &quot;Saiyajin&quot;) {:error, :type_value_wrong} Examples list iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :list}, [&quot;Saiyajin&quot;, &quot;Namek&quot;]) {:ok, [&quot;Saiyajin&quot;, &quot;Namek&quot;]} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :list}, &quot;Saiyajin&quot;) {:error, :type_value_wrong} Examples map iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :map}, %{&quot;Saiyajin&quot; =&gt; &quot;Vegetta&quot;}) {:ok, %{&quot;Saiyajin&quot; =&gt; &quot;Vegetta&quot;}} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :map}, &quot;Saiyajin&quot;) {:error, :type_value_wrong} Examples tuple iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :tuple}, {&quot;Saiyajin&quot;, &quot;Namek&quot;}) {:ok, {&quot;Saiyajin&quot;, &quot;Namek&quot;}} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :tuple}, &quot;Saiyajin&quot;) {:error, :type_value_wrong} Examples number iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :number}, 3) {:ok, 3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :number}, 3.3) {:ok, 3.3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :number}, &quot;3&quot;) {:ok, 3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :number}, &quot;3.3&quot;) {:ok, 3.3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :number}, &quot;Thr.ee&quot;) {:error, :type_value_wrong} Examples float iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :float}, 3.3) {:ok, 3.3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :float}, &quot;3.3&quot;) {:ok, 3.3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :float}, &quot;Vegeta&quot;) {:error, :type_value_wrong} Examples integer iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :integer}, 3) {:ok, 3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :integer}, &quot;3&quot;) {:ok, 3} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :integer}, &quot;Vegeta&quot;) {:error, :type_value_wrong} Examples boolean iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, true) {:ok, true} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, false) {:ok, false} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, &quot;true&quot;) {:ok, true} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, &quot;false&quot;) {:ok, false} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, &quot;TRUE&quot;) {:ok, true} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, &quot;FALSE&quot;) {:ok, false} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, &quot;1&quot;) {:ok, true} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, &quot;0&quot;) {:ok, false} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, 1) {:ok, true} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, 0) {:ok, false} iex(3)&gt; Exvalidate.Rules.Type.validating({:type, :boolean}, &quot;Vegeta&quot;) {:error, :type_value_wrong} The :number type includes the types :float and :integer.","ref":"Exvalidate.Rules.Type.html","title":"Exvalidate.Rules.Type","type":"module"}]